Unit QTT9R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure QTT9R(var RINT :Real; var X1 :Array of Real;
                var X2 :Array of Real; var X3 :Array of Real;
                var F :Array of Real; N :Integer; M :Integer;
                L :Integer);

implementation

procedure QTT9R(var RINT :Real; var X1 :Array of Real;
                var X2 :Array of Real; var X3 :Array of Real;
                var F :Array of Real; N :Integer; M :Integer;
                L :Integer);
var
N1,M1,L1,I,J,K :Integer;
S1,S2 :Real;
label
_1,_2,_3;
begin
N1 := N-1;
M1 := M-1;
L1 := L-1;
RINT := 0.0;
for K:=1 to L1 do
 begin
  S2 := 0.0;
  for J:=1 to M1 do
   begin
    S1 := 0.0;
    for I:=1 to N1 do
     begin
_1:
      S1 := S1+(F[(I-1)+(J-1)*N+(K-1)*N*M]+F[(I-1)+(J-1)*N+(K+0)*N*M]+F[(I-1)+(J+0)*N+(K-1)*N*M]+F[(I-1)+(J+0)*N+(K+0)*N*M]+
    F[(I+0)+(J-1)*N+(K-1)*N*M]+F[(I+0)+(J-1)*N+(K+0)*N*M]+F[(I+0)+(J+0)*N+(K-1)*N*M]+F[(I+0)+(J+0)*N+(K+0)*N*M])*
    (X1[I+0]-X1[I-1]);
     end;
_2:
    S2 := S2+S1*(X2[J+0]-X2[J-1]);
   end;
_3:
  RINT := RINT+S2*(X3[K+0]-X3[K-1]);
 end;
RINT := RINT/8.0;
end;

end.
